﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using SfDataGridSample.Model;
using Syncfusion.Windows.Shared;
using Syncfusion.UI.Xaml.Grid;
using System.Windows;
using System.Windows.Threading;
using System.Windows.Input;

namespace SfDataGridSample
{
    class ViewModel:INotifyPropertyChanged
    {
        EmployeeDetails emp = new EmployeeDetails();

        #region Constructor
        DispatcherTimer timer;

        public ViewModel()
        {
            this.Employees = emp;
            _nullCommand = new DelegateCommand(EmptyCollectionMethod, CanEmpty);
            timer = new DispatcherTimer();
            timer.Interval = new TimeSpan(0, 0, 5);
            //timer.Tick += timer_Tick;
            timer.Start();
        }

        int i = 10;
        void timer_Tick(object sender, object e)
        {
            if(i % 2 == 0)
            {
                this.Employees = emp;                
            }
            else
            {
                this.Employees = null;
            }
            i++;
        }

        private DelegateCommand _nullCommand;

        public DelegateCommand NullCommand
        {
            get
            {
                return _nullCommand;
            }
        }

        public bool CanEmpty(object param)
        {
            return true;
        }

        public void EmptyCollectionMethod(object parameter)
        {
            var treegrid = parameter as SfDataGrid;                        
        }

        #endregion

        private ObservableCollection<BusinessObjects> employees;
        public ObservableCollection<BusinessObjects> Employees
        {
            get
            {
                return employees;
            }
            set
            {
                employees = value;
                OnPropertyChanged("Employees");
            }
        }              


        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion

        private string searchText;

        public string SearchText
        {
            get { return searchText; }
            set { searchText = value; }
        }
      
    }
    
    #region GDCSource DataSource
    class EmployeeDetails : ObservableCollection<BusinessObjects>
    {
        Random rand = new Random();
        public EmployeeDetails()
        {
            PopulateCollection();
        }

        private void PopulateCollection()
        {
            this.Clear();

          //  for (int i = 0; i < 700; i++)
            {
                BusinessObjects b = new BusinessObjects() { EmployeeName = "Mart", JoiningDate=DateTime.Now, EmployeeAge = 45, EmployeeArea = "USA", EmployeeSalary = 33000, ExperienceInMonth = 10, EmployeeGender = "Male" , Rating = 2, CheckBoxValue = true };
                this.Add(b);
                b = new BusinessObjects() { EmployeeName = "Peter", EmployeeAge = 35, EmployeeArea = "UK", EmployeeSalary = 5678, ExperienceInMonth = 10, EmployeeGender = "Male", Rating = 1, CheckBoxValue = true };
                this.Add(b);
                b = new BusinessObjects() { EmployeeName = "James",EmployeeAge = 42, EmployeeArea = "UAE", EmployeeSalary = 18700, ExperienceInMonth = 10, EmployeeGender = "Male", Rating = 3, CheckBoxValue = true };
                this.Add(b);
                b = new BusinessObjects() { EmployeeName = "Oliver", EmployeeAge = 36, EmployeeArea = "USA", EmployeeSalary = 67000, ExperienceInMonth = 10, EmployeeGender = "Male", Rating = 4, CheckBoxValue = false };
                this.Add(b);
                b = new BusinessObjects() { EmployeeName = "Robert",  EmployeeAge = 54, EmployeeArea = "India", EmployeeSalary = 34567, ExperienceInMonth = 10, EmployeeGender = "Male", Rating = 5, CheckBoxValue = true };
                this.Add(b);
                b = new BusinessObjects() { EmployeeName = "Suji",EmployeeAge = 45, EmployeeArea = "UK", EmployeeSalary = 90000, ExperienceInMonth = 10, EmployeeGender = "Female", Rating = 2, CheckBoxValue = false };
                this.Add(b);
                b = new BusinessObjects() { EmployeeName = "Mahesh",EmployeeAge = 48, EmployeeArea = "UK", EmployeeSalary = 34567, ExperienceInMonth = 10, EmployeeGender = "Male", Rating = 1, CheckBoxValue = true };
                this.Add(b);
                b = new BusinessObjects() { EmployeeName = "Ruby",  EmployeeAge = 49, EmployeeArea = "UK", EmployeeSalary = 12345, ExperienceInMonth = 10, EmployeeGender = "Female", Rating = 3, CheckBoxValue = false };
                this.Add(b);
                b = new BusinessObjects() { EmployeeName = "Christain", EmployeeAge = 54, EmployeeArea = "India", EmployeeSalary = 80000, ExperienceInMonth = 10, EmployeeGender = "Male", Rating = 4, CheckBoxValue = true };
                this.Add(b);
                b = new BusinessObjects() { EmployeeName = "Aravind",  EmployeeAge = 65, EmployeeArea = "India", EmployeeSalary = 12000, ExperienceInMonth = 10, EmployeeGender = "Male", Rating = 5, CheckBoxValue = false };
                this.Add(b);
                b = new BusinessObjects() { EmployeeName = "Daniel", EmployeeAge = 56, EmployeeArea = "USA", EmployeeSalary = 16000, ExperienceInMonth = 10, EmployeeGender = "Male", Rating = 2, CheckBoxValue = true };
                this.Add(b);
                b = new BusinessObjects() { EmployeeName = "Suhitha Azar",  EmployeeAge = 78, EmployeeArea = "UK", EmployeeSalary = 98789, ExperienceInMonth = 10, EmployeeGender = "Female", Rating = 3, CheckBoxValue = false };
                this.Add(b);
                b = new BusinessObjects() { EmployeeName = "Praveen", EmployeeAge = 54, EmployeeArea = "UAE", EmployeeSalary = 45678, ExperienceInMonth = 10, EmployeeGender = "Male", Rating = 3, CheckBoxValue = true };
                this.Add(b);
                b = new BusinessObjects() { EmployeeName = "Stephen",  EmployeeAge = 45, EmployeeArea = "USA", EmployeeSalary = 21000, ExperienceInMonth = 10, EmployeeGender = "Male", Rating = 1, CheckBoxValue = false };
                this.Add(b);
                b = new BusinessObjects() { EmployeeName = "Asha Joseph", EmployeeAge = 56, EmployeeArea = "India", EmployeeSalary = 56787, ExperienceInMonth = 10, EmployeeGender = "Female", Rating = 4, CheckBoxValue = true };
                this.Add(b);
                b = new BusinessObjects() { EmployeeName = "Clarke", EmployeeAge = 67, EmployeeArea = "UK", EmployeeSalary = 1200, ExperienceInMonth = 10, EmployeeGender = "Male", Rating = 2, CheckBoxValue = false };
                this.Add(b);
                b = new BusinessObjects() { EmployeeName = "Dhileep Venkatesh",  EmployeeAge = 45, EmployeeArea = "UK", EmployeeSalary = 45656, ExperienceInMonth = 10, EmployeeGender = "Male", Rating = 5, CheckBoxValue = false };
            }

        }
    }

    #endregion
}
